/* msx-emul is (C) 2008-2009 by folkert@vanheusden.com
 * released under GPL
 */
static char *rcsId = "$Id$";

#include <z80ex/z80ex.h>
#include <stdio.h>

extern unsigned char ports[256];
unsigned char hbi55sram[4096];

unsigned char read_hbi_55(Z80EX_WORD port)
{
	if (port == 0xb0 || port == 0xb1 || port == 0xb3)
		return ports[port];

	/* 0xb1 bit 6 should also be 1 */
	if (port == 0xb2 && ((ports[0xb1] & 128) == 128 && ports[0xb3] == 0x89))
	{
		return hbi55sram[ports[0xb0] + ((ports[0xb1] & 15) << 8)];
	}

	return -1;
}

void write_hbi_55(Z80EX_WORD port, Z80EX_BYTE value)
{
	if (port == 0xb0 || port == 0xb1 || port == 0xb3)
	{
		ports[port] = value;
		return;
	}

	/* 0xb1 bit 6 should also be 1 */
	if (port == 0xb2 && ((ports[0xb1] & 128) == 0 && ports[0xb0] == 0x80))
	{
		hbi55sram[ports[0xb0] + ((ports[0xb1] & 15) << 8)] = value;
		return;
	}
}
