typedef enum { rom_bios, rom_generic, rom_megarom_konami4, rom_megarom_konami5, rom_msx2exp, rom_diskrom, rom_megarom_msxdos2, rom_ascii_16kb } rom_t;

typedef struct
{
	char *file, *parameter;
	int slot, subslot;
	rom_t type;
} roms_t;

/* generic rom/ram */
extern unsigned char sub_page_selection[4];
extern unsigned char *memory[4][4][4];
extern char rom[4][4][4];
extern char has_subpages[4];
/* memory mapper: needed by portsrw for bank selection */
extern unsigned char mapper_bank_selection[4];
typedef struct
{
	int mapper_slot, mapper_sub_slot;
	unsigned char *mapper;
} mapper_t;
extern mapper_t *mappers;
extern int n_mappers;
/* megaroms */
typedef struct
{
	int megarom_slot, megarom_sub_slot;
	rom_t megarom_mapper_type;
	unsigned char *megarom;
	unsigned char megarom_bank_selection[4];
	int size;
	char scc_selected;
} megarom_t;
extern megarom_t *megaroms;
extern int n_megaroms;

inline void split_addr(Z80EX_WORD addr, int *page, int *slot, int *sub_page, int *mem);
void write_mem_cb(Z80EX_CONTEXT *cpu, Z80EX_WORD addr, Z80EX_BYTE value, void *user_data);
inline Z80EX_BYTE read_mem_cb(Z80EX_CONTEXT *cpu, Z80EX_WORD addr, int m1_state, void *user_data);
inline Z80EX_BYTE read_mem_dis(Z80EX_WORD addr, void *user_data);
void init_memory(roms_t *roms, int n_roms);
